Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -506,42 +527,42 @@
 
 
- CALL run_control('time', 'init')
-!
-!--    Read COSMO soil type map
-       cosmo_var % name = 'SOILTYP'
-       CALL get_netcdf_variable(cfg % soiltyp_file, cosmo_var, soiltyp)
-
-       message = 'Reading PALM-4U origin from'
-       IF (TRIM(cfg % static_driver_file) .NE. '')  THEN
-
-          origin_lon = get_netcdf_attribute(cfg % static_driver_file, 'origin_lon')
-          origin_lat = get_netcdf_attribute(cfg % static_driver_file, 'origin_lat')
-
-          message = TRIM(message) // " static driver file '"                   &
-                                  // TRIM(cfg % static_driver_file) // "'"
-
-
-       ELSE
-
-          origin_lon = longitude
-          origin_lat = latitude
-
-          message = TRIM(message) // " namlist file '"                         &
-                                  // TRIM(cfg % namelist_file) // "'"
-
-       ENDIF
-       origin_lon = origin_lon * TO_RADIANS
-       origin_lat = origin_lat * TO_RADIANS
-
-       CALL report('setup_parameters', message)
-
- CALL run_control('time', 'read')
-
-       CALL get_cosmo_grid( cfg, soil_files(1), rlon, rlat, hhl, hfl, depths,  &
-                            d_depth, d_depth_rho_inv, phi_n, lambda_n,         &
-                            phi_equat,                                         &
-                            lonmin_cosmo, lonmax_cosmo,                        &
-                            latmin_cosmo, latmax_cosmo,                        &
-                            nlon, nlat, nlev, ndepths )
+    CALL log_runtime('time', 'init')
+!
+!-- Read COSMO soil type map
+    cosmo_var%name = 'SOILTYP'
+    CALL get_netcdf_variable(cfg%soiltyp_file, cosmo_var, soiltyp)
+
+    message = 'Reading PALM-4U origin from'
+    IF (TRIM(cfg%static_driver_file) .NE. '')  THEN
+
+       origin_lon = get_netcdf_attribute(cfg%static_driver_file, 'origin_lon')
+       origin_lat = get_netcdf_attribute(cfg%static_driver_file, 'origin_lat')
+
+       message = TRIM(message) // " static driver file '"                   &
+                               // TRIM(cfg%static_driver_file) // "'"
+
+
+    ELSE
+
+       origin_lon = longitude
+       origin_lat = latitude
+
+       message = TRIM(message) // " namlist file '"                         &
+                               // TRIM(cfg%namelist_file) // "'"
+
+    ENDIF
+    origin_lon = origin_lon * TO_RADIANS
+    origin_lat = origin_lat * TO_RADIANS
+
+    CALL report('setup_parameters', message)
+
+    CALL log_runtime('time', 'read')
+
+    CALL get_cosmo_grid( cfg, soil_files(1), rlon, rlat, hhl, hfl, depths,  &
+                         d_depth, d_depth_rho_inv, phi_n, lambda_n,         &
+                         phi_equat,                                         &
+                         lonmin_cosmo, lonmax_cosmo,                        &
+                         latmin_cosmo, latmax_cosmo,                        &
+                         nlon, nlat, nlev, ndepths )
 
 
@@ -550,71 +571,71 @@
 !------------------------------------------------------------------------------
 !
-!--    PALM-4U domain extents
-       lx = (nx+1) * dx
-       ly = (ny+1) * dy
-       
-!
-!--    PALM-4U point of Earth tangency
-       x0 = 0.0_dp
-       y0 = 0.0_dp
-
-!
-!--    time vector
-       nt = CEILING(end_time / (step_hour * 3600.0_dp)) + 1
-       ALLOCATE( time(nt) )
-       CALL linspace(0.0_dp, 3600.0_dp * (nt-1), time)
-       output_file % time => time
- CALL run_control('time', 'init')
-
-!
-!--    Convert the PALM-4U origin coordinates to COSMO's rotated-pole grid
-       phi_c    = TO_RADIANS *                                                 &
-                  phi2phirot( origin_lat * TO_DEGREES, origin_lon * TO_DEGREES,&
-                              phi_n * TO_DEGREES, lambda_n * TO_DEGREES )
-       lambda_c = TO_RADIANS *                                                 &
-                  rla2rlarot( origin_lat * TO_DEGREES, origin_lon * TO_DEGREES,&
-                              phi_n * TO_DEGREES, lambda_n * TO_DEGREES,     &
-                              0.0_dp )
-
-!
-!--    Set gamma according to whether PALM domain is in the northern or southern
-!--    hemisphere of the COSMO rotated-pole system. Gamma assumes either the
-!--    value 0 or PI and is needed to work around around a bug in the
-!--    rotated-pole coordinate transformations.
-       gam = gamma_from_hemisphere(origin_lat, phi_equat)
-
-!
-!--    Compute the north pole of the rotated-pole grid centred at the PALM-4U
-!--    domain centre. The resulting (phi_cn, lambda_cn) are coordinates in
-!--    COSMO-DE's rotated-pole grid.
-       phi_cn    = phic_to_phin(phi_c) 
-       lambda_cn = lamc_to_lamn(phi_c, lambda_c) 
-
-       message =   "PALM-4U origin:" // NEW_LINE('') // &
-          "           lon (lambda) = " // &
-          TRIM(real_to_str_f(origin_lon * TO_DEGREES)) // " deg"// NEW_LINE(' ') //&
-          "           lat (phi   ) = " // &
-          TRIM(real_to_str_f(origin_lat * TO_DEGREES)) // " deg (geographical)" // NEW_LINE(' ') //&
-          "           lon (lambda) = " // &
-          TRIM(real_to_str_f(lambda_c * TO_DEGREES)) // " deg" // NEW_LINE(' ') // &
-          "           lat (phi   ) = " // &
-          TRIM(real_to_str_f(phi_c * TO_DEGREES)) // " deg (COSMO-DE rotated-pole)"
-      CALL report ('setup_parameters', message)
-
-       message = "North pole of the rotated COSMO-DE system:" // NEW_LINE(' ') // &
-          "           lon (lambda) = " // &
-          TRIM(real_to_str_f(lambda_n * TO_DEGREES)) // " deg" // NEW_LINE(' ') //&
-          "           lat (phi   ) = " // &
-          TRIM(real_to_str_f(phi_n * TO_DEGREES)) // " deg (geographical)"
-       CALL report ('setup_parameters', message)
-          
-       message = "North pole of the rotated palm system:" // NEW_LINE(' ') // &
-          "           lon (lambda) = " // &
-          TRIM(real_to_str_f(lambda_cn * TO_DEGREES)) // " deg" // NEW_LINE(' ') // &
-          "           lat (phi   ) = " // &
-          TRIM(real_to_str_f(phi_cn * TO_DEGREES)) // " deg (COSMO-DE rotated-pole)"
-       CALL report ('setup_parameters', message)
-
- CALL run_control('time', 'comp')
+!-- PALM-4U domain extents
+    lx = (nx+1) * dx
+    ly = (ny+1) * dy
+    
+!
+!-- PALM-4U point of Earth tangency
+    x0 = 0.0_wp
+    y0 = 0.0_wp
+
+!
+!-- time vector
+    nt = CEILING(end_time / (step_hour * 3600.0_wp)) + 1
+    ALLOCATE( time(nt) )
+    CALL linspace(0.0_wp, 3600.0_wp * (nt-1), time)
+    output_file%time => time
+    CALL log_runtime('time', 'init')
+
+!
+!-- Convert the PALM-4U origin coordinates to COSMO's rotated-pole grid
+    phi_c    = TO_RADIANS *                                                 &
+               phi2phirot( origin_lat * TO_DEGREES, origin_lon * TO_DEGREES,&
+                           phi_n * TO_DEGREES, lambda_n * TO_DEGREES )
+    lambda_c = TO_RADIANS *                                                 &
+               rla2rlarot( origin_lat * TO_DEGREES, origin_lon * TO_DEGREES,&
+                           phi_n * TO_DEGREES, lambda_n * TO_DEGREES,     &
+                           0.0_wp )
+
+!
+!-- Set gamma according to whether PALM domain is in the northern or southern
+!-- hemisphere of the COSMO rotated-pole system. Gamma assumes either the
+!-- value 0 or PI and is needed to work around around a bug in the
+!-- rotated-pole coordinate transformations.
+    gam = gamma_from_hemisphere(origin_lat, phi_equat)
+
+!
+!-- Compute the north pole of the rotated-pole grid centred at the PALM-4U
+!-- domain centre. The resulting (phi_cn, lambda_cn) are coordinates in
+!-- COSMO-DE's rotated-pole grid.
+    phi_cn    = phic_to_phin(phi_c) 
+    lambda_cn = lamc_to_lamn(phi_c, lambda_c) 
+
+    message =   "PALM-4U origin:" // NEW_LINE('') // &
+       "           lon (lambda) = " // &
+       TRIM(real_to_str_f(origin_lon * TO_DEGREES)) // " deg"// NEW_LINE(' ') //&
+       "           lat (phi   ) = " // &
+       TRIM(real_to_str_f(origin_lat * TO_DEGREES)) // " deg (geographical)" // NEW_LINE(' ') //&
+       "           lon (lambda) = " // &
+       TRIM(real_to_str_f(lambda_c * TO_DEGREES)) // " deg" // NEW_LINE(' ') // &
+       "           lat (phi   ) = " // &
+       TRIM(real_to_str_f(phi_c * TO_DEGREES)) // " deg (COSMO-DE rotated-pole)"
+    CALL report ('setup_parameters', message)
+
+    message = "North pole of the rotated COSMO-DE system:" // NEW_LINE(' ') // &
+       "           lon (lambda) = " // &
+       TRIM(real_to_str_f(lambda_n * TO_DEGREES)) // " deg" // NEW_LINE(' ') //&
+       "           lat (phi   ) = " // &
+       TRIM(real_to_str_f(phi_n * TO_DEGREES)) // " deg (geographical)"
+    CALL report ('setup_parameters', message)
+       
+    message = "North pole of the rotated palm system:" // NEW_LINE(' ') // &
+       "           lon (lambda) = " // &
+       TRIM(real_to_str_f(lambda_cn * TO_DEGREES)) // " deg" // NEW_LINE(' ') // &
+       "           lat (phi   ) = " // &
+       TRIM(real_to_str_f(phi_cn * TO_DEGREES)) // " deg (COSMO-DE rotated-pole)"
+    CALL report ('setup_parameters', message)
+
+    CALL log_runtime('time', 'comp')
 
 !------------------------------------------------------------------------------
@@ -625,6 +646,6 @@
 !-- Compute coordiantes of the PALM centre in the source (COSMO) system
     phi_centre = phirot2phi(                                                   &
-       phirot = project(0.5_dp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
-       rlarot = project(0.5_dp*lx, x0, EARTH_RADIUS) * TO_DEGREES,             &
+       phirot = project(0.5_wp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
+       rlarot = project(0.5_wp*lx, x0, EARTH_RADIUS) * TO_DEGREES,             &
        polphi = phi_cn * TO_DEGREES,                                           &
        polgam = gam * TO_DEGREES                                               &
@@ -632,6 +653,6 @@
 
     lam_centre = rlarot2rla(                                                   &
-       phirot = project(0.5_dp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
-       rlarot = project(0.5_dp*lx, x0, EARTH_RADIUS) * TO_DEGREES,             &
+       phirot = project(0.5_wp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
+       rlarot = project(0.5_wp*lx, x0, EARTH_RADIUS) * TO_DEGREES,             &
        polphi = phi_cn * TO_DEGREES, pollam = lambda_cn * TO_DEGREES,          &
        polgam = gam * TO_DEGREES                                               &
@@ -647,9 +668,9 @@
 !
 !-- Compute boundaries of the central averaging box
-    averaging_angle = cfg % averaging_angle * TO_RADIANS
-    lam_east = lam_centre + 0.5_dp * averaging_angle
-    lam_west = lam_centre - 0.5_dp * averaging_angle
-    phi_north = phi_centre + 0.5_dp * averaging_angle
-    phi_south = phi_centre - 0.5_dp * averaging_angle
+    averaging_angle = cfg%averaging_angle * TO_RADIANS
+    lam_east = lam_centre + 0.5_wp * averaging_angle
+    lam_west = lam_centre - 0.5_wp * averaging_angle
+    phi_north = phi_centre + 0.5_wp * averaging_angle
+    phi_south = phi_centre - 0.5_wp * averaging_angle
     averaging_width_ew = averaging_angle * COS(phi_centre) * EARTH_RADIUS
     averaging_width_ns = averaging_angle * EARTH_RADIUS
@@ -674,5 +695,5 @@
 !
 !-- Coriolis parameter
-    f3 = 2.0_dp * OMEGA * SIN(                                                 &
+    f3 = 2.0_wp * OMEGA * SIN(                                                 &
        TO_RADIANS*phirot2phi( phi_centre * TO_DEGREES, lam_centre * TO_DEGREES,&
                               phi_n * TO_DEGREES,                              &
@@ -680,5 +701,5 @@
     )
 
-    END SUBROUTINE setup_parameters
+ END SUBROUTINE setup_parameters
 
 
@@ -689,6 +710,6 @@
 !> coordinates and interpolation weights
 !------------------------------------------------------------------------------!
-    SUBROUTINE setup_grids()
-       CHARACTER ::  interp_mode
+ SUBROUTINE setup_grids()
+    CHARACTER ::  interp_mode
 
 !------------------------------------------------------------------------------
@@ -696,28 +717,28 @@
 !------------------------------------------------------------------------------
 !
-!--    palm x y z, we allocate the column to nz+1 in order to include the top
-!--    scalar boundary. The interpolation grids will be associated with
-!--    a shorter column that omits the top element.
-       ALLOCATE( x(0:nx), y(0:ny), z(1:nz), z_column(1:nz+1) )
-       CALL linspace(0.5_dp * dx, lx - 0.5_dp * dx, x)
-       CALL linspace(0.5_dp * dy, ly - 0.5_dp * dy, y)
-       CALL stretched_z(z_column, dz, dz_max=dz_max,                           &
-                        dz_stretch_factor=dz_stretch_factor,                   &
-                        dz_stretch_level=dz_stretch_level,                     &
-                        dz_stretch_level_start=dz_stretch_level_start,         &
-                        dz_stretch_level_end=dz_stretch_level_end,             &
-                        dz_stretch_factor_array=dz_stretch_factor_array)
-       z(1:nz) = z_column(1:nz)
-       z_top = z_column(nz+1)
-
-!
-!--    palm xu yv zw, compared to the scalar grid, velocity coordinates
-!--    contain one element less.
-       ALLOCATE( xu(1:nx),  yv(1:ny), zw(1:nz-1), zw_column(1:nz))
-       CALL linspace(dx, lx - dx, xu)
-       CALL linspace(dy, ly - dy, yv)
-       CALL midpoints(z_column, zw_column)
-       zw(1:nz-1) = zw_column(1:nz-1)
-       zw_top     = zw_column(nz)
+!-- palm x y z, we allocate the column to nz+1 in order to include the top
+!-- scalar boundary. The interpolation grids will be associated with
+!-- a shorter column that omits the top element.
+    ALLOCATE( x(0:nx), y(0:ny), z(1:nz), z_column(1:nz+1) )
+    CALL linspace(0.5_wp * dx, lx - 0.5_wp * dx, x)
+    CALL linspace(0.5_wp * dy, ly - 0.5_wp * dy, y)
+    CALL stretched_z(z_column, dz, dz_max=dz_max,                           &
+                     dz_stretch_factor=dz_stretch_factor,                   &
+                     dz_stretch_level=dz_stretch_level,                     &
+                     dz_stretch_level_start=dz_stretch_level_start,         &
+                     dz_stretch_level_end=dz_stretch_level_end,             &
+                     dz_stretch_factor_array=dz_stretch_factor_array)
+    z(1:nz) = z_column(1:nz)
+    z_top = z_column(nz+1)
+
+!
+!-- palm xu yv zw, compared to the scalar grid, velocity coordinates
+!-- contain one element less.
+    ALLOCATE( xu(1:nx),  yv(1:ny), zw(1:nz-1), zw_column(1:nz))
+    CALL linspace(dx, lx - dx, xu)
+    CALL linspace(dy, ly - dy, yv)
+    CALL midpoints(z_column, zw_column)
+    zw(1:nz-1) = zw_column(1:nz-1)
+    zw_top     = zw_column(nz)
 
 
